        program test
        dimension sp_f(3)
        pi = acos(-1.0)       
        pm = 0.938279         
        dm = 1.875628 

*     Initialization
	icon = 0
        iw   = 1
        call sigma_ed(ei,q2,pr,thr,phir,ktf,sp_f,noff,npv,npro,icon,
     &                iv1,iv2,isd,iw,ipp,crs,ifl,q0)

*
**************************************
*       INPUT   PARAMETERS   
**************************************
        ei   = 11.00         ! initial electron energy
        pr   = 0.1           ! recoil nucleon momentum GeV/C
        thr  = 71.*pi/180.   ! polar angle of the recoil nucleon
        phir = pi            ! azimuthal angle of the recoil nucleon
        ktf  = 1             ! the knock-out nucleon is proton(1), neutron(-1)
        noff = 1             ! Off-Shell effects included (1) not included (0)
        npv  = 0             ! only pole term in FSI (0), pole+PV (1) 
        npro = 1             ! it calculates d\sigma/dE'_e d\Omega_e d\Omega_pf
        icon = 0             ! calculate (initialization parameter)
        isd  = 1             ! spectatro mechanism
        ipp  = 0             ! S and D component in deuteron
        q2 =   4.0
                
*********************************************************************
*         fixing knock-out nucleons polarization axis along z
*********************************************************************
         sp_f(1) = 0.0; sp_f(2) = 0.0; sp_f(3) = 1.0

        do ithr = 10,180,5
           thr0 = float(ithr)   ! recoil nucleon polar angle
           thr  = thr0*pi/180.0

        do ipr = 10,10
           pr = float(ipr)/10.  ! recoil nucleon momentum


 
         icon=1                ! PWIA
         call sigma_ed(ei,q2,pr,thr,phir,ktf,sp_f,noff,npv,npro,icon,
     &               iv1,iv2,isd,iw,ipp,crs0,ifl,q0)

 
         iv1 = 3            ! FSI with diffractive parameterization for f_nn
         iv2 = 10           ! Charge Exchange Gibbs_Luiseu parameterisation
         icon=12!3           ! PWI+FSI !+CHEX
        call sigma_ed(ei,q2,pr,thr,phir,ktf,sp_f,noff,npv,npro,icon,
     &               iv1,iv2,isd,iw,ipp,crs12,ifl,q0)

*         icon = 12
*         iv1  = 1
*         iv2  = 10021
*        call sigma_ed(ei,q2,pr,thr,phir,ktf,noff,npro,icon,
*     &                 iv1,iv2,isd,iw,ipp,crs,ifl,q0)
        if(ifl.eq.1)goto 1      ! kinematically forbidden
        x = q2/(2.0*pm*q0)
        ratio = 0
        if(crs0.ne.0.0)ratio=crs12/crs0
 
        tiv = 0.389385*1000.*1000.
        s = dm**2 + 2.0*dm*q0 - q2
        elab = (s-2.0*pm**2)/(2.0*pm)
        plab = sqrt(elab**2-pm**2)


        write(6,*)q2,pr,thr0,x,plab,crs0,crs12,ratio

        write(12,*)thr0,pr,ei,q2,x,plab,crs0,crs12,ratio

1       continue
        enddo
*        write(6,9)thr0,ei,q2,x1,x2,x3,x4,x5
*        write(12,10)thr0,ei,q2,x1,x2,x3,x4,x5
        enddo

         
  	end






